Unit AMZ7R_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc;

procedure AMZ7R(var A :Array of Real; N :Integer; NC :Integer;
                var B :Array of Real); 
implementation

procedure AMZ7R(var A :Array of Real; N :Integer; NC :Integer;
                var B :Array of Real);
var
NP1,NCP1,NCP2,NMNC,JJ,KK,K,I,II,J,IJ :Integer;
const
ZERO :Real = 0.0E0;
label
_1,_2,_3,_4,_5;
begin
NP1 := N+1;
NCP1 := NC+1;
NCP2 := NCP1+1;
NMNC := N-NC;
JJ := NCP1;
KK := (N*(N+1)) div 2;
K := KK;
for I:=1 to N do
 begin
  II := NP1-I;
  for J:=1 to JJ do
   begin
    IJ := NCP2-J;
    B[(II-1)+(IJ-1)*N] := A[K-1];
    K := K-1;
_1:
   end;
  K := KK-II;
  KK := K;
  if ( I >= NMNC ) 
   then JJ := JJ-1;
_2:
 end;
if ( NCP1 = 1 ) 
 then goto _5;
JJ := NC;
for I:=1 to NC do
 begin
  for J:=1 to JJ do
   begin
    B[(I-1)+(J-1)*N] := ZERO;
_3:
   end;
  JJ := JJ-1;
_4:
 end;
_5:
end;

end.
